# JeviLib Debug
## A multifunction library for code modders, containing serialization utilities and tweening.

## What's the difference?

This version was built with the `DEBUG` compiler flag. This means that there are extra checks and log points. *This means decreased performance*, but you will be warned when you attempt to perform invalid operations.

You should not rely on the increased checks for your code. This version should **not** be the version you depend on. You should depend on the normal version of [JeviLib](https://boneworks.thunderstore.io/package/extraes/JeviLib/).

---


## What does it do?

This library holds a bunch of utilities I found necessary to create whilst I created [BW Chaos](https://boneworks.thunderstore.io/package/BWChaosDevs/BW_Chaos/), and that continues to remain useful on other projects. In these utilities are my `Prefs` system, numerous extension methods, and my serialization utilities (byte array lossless joiner and separator, `Vector3` byte converter).

Additionally, this contains an extensible tweener that code modders can use to smoothly transition the state of values from a starting value to another, with a position and scale tweener built in.

# Changelog

 - 1.1.0
   - Add more Tweens, like extensions for AudioTween, and RotationTween.
   - Add more Tween extension methods, like `Unique`.
   - Add `Jevil.Spawning` namespace, so far just used for spawning EarlyExits of different varieties and spawning Ammo boxes. Untested, so good luck lol.
   - BREAKING CHANGE: Use record type for PrefEntries, so field/property names have changed.

 - 1.0.1
   - Fix Thunderstore website link
   - Change some docs
   - Build as release

 - 1.0.0
   - Initial upload